﻿using System.Collections.Immutable;
using Connected.Annotations;
using Connected.Net.Endpoints;

namespace Connected.Net.Server;

[Service]
[ServiceUrl(Routes.Server)]
public interface IEndpointServer
{
	event EventHandler<ServerChangedArgs>? Changed;
	event EventHandler Initialized;

	Task Initialize(ImmutableList<IEndpoint> endpoints, CancellationToken cancellationToken);

	[ServiceMethod(ServiceMethodVerbs.Post)]
	Task NotifyServerChange(ServerProposalArgs args);

	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<bool> IsServer();

	string ServerUrl { get; }
}
