﻿using Connected.Middleware;
using Connected.ServiceModel;

namespace Connected.Notifications.Events;
public abstract class EventListener<TArgs> : MiddlewareComponent, IEventListener<TArgs>
	where TArgs : IDto
{
	protected TArgs Arguments { get; private set; } = default!;
	protected IOperationState Sender { get; private set; } = default!;

	public async Task Invoke(IOperationState sender, TArgs args)
	{
		Sender = sender;
		Arguments = args;

		await OnInvoke();
	}

	protected virtual async Task OnInvoke()
	{
		await Task.CompletedTask;
	}
}
