﻿using System.Collections.Immutable;

namespace Connected.Services.Authorization;

public interface IServiceAuthorizationMiddleware : IMiddleware
{
	Task<ImmutableArray<string>> ResolveClaims(ImmutableArray<string> claims);

	Task Authorize<TArgs>(ServiceAuthorizationMiddlewareArgs<TArgs> args)
		where TArgs : IDto;

	Task<TEntity> Authorize<TArgs, TEntity>(ServiceAuthorizationMiddlewareArgs<TArgs> args, TEntity entity)
		where TArgs : IDto;
}
